// Borland C++ Builder
// Copyright (c) 1995, 1998 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'EsCal.pas' rev: 3.00

#ifndef EsCalHPP
#define EsCalHPP
#include <EsUtil.hpp>
#include <EsData.hpp>
#include <EsBase.hpp>
#include <SysUtils.hpp>
#include <Messages.hpp>
#include <Menus.hpp>
#include <Forms.hpp>
#include <Graphics.hpp>
#include <Controls.hpp>
#include <Classes.hpp>
#include <Buttons.hpp>
#include <Windows.hpp>
#include <SysInit.hpp>
#include <System.hpp>

//-- user supplied -----------------------------------------------------------

namespace Escal
{
//-- type declarations -------------------------------------------------------
enum TEsDateFormat { dfShort, dfLong };

typedef Shortint TEsDayNameWidth;

enum TEsDayType { dtSunday, dtMonday, dtTuesday, dtWednesday, dtThursday, dtFriday, dtSaturday };

typedef Graphics::TColor TEsCalColorArray[6];

enum TEsCalColorScheme { csCustom, csWindows, csGold, csOcean, csRose };

typedef Graphics::TColor TEsCalSchemeArray[5][6];

class DELPHICLASS TEsCalColors;
class PASCALIMPLEMENTATION TEsCalColors : public Classes::TPersistent 
{
	typedef Classes::TPersistent inherited;
	
private:
	bool FUpdating;
	Classes::TNotifyEvent FOnChange;
	bool SettingScheme;
	void __fastcall DoOnChange(void);
	Graphics::TColor __fastcall GetColor(int Index);
	void __fastcall SetColor(int Index, Graphics::TColor Value);
	void __fastcall SetColorScheme(TEsCalColorScheme Value);
	
public:
	Graphics::TColor FCalColors[6];
	TEsCalColorScheme FColorScheme;
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	void __fastcall BeginUpdate(void);
	void __fastcall EndUpdate(void);
	__property Classes::TNotifyEvent OnChange = {read=FOnChange, write=FOnChange};
	
__published:
	__property Graphics::TColor ActiveDay = {read=GetColor, write=SetColor, index=0, nodefault};
	__property TEsCalColorScheme ColorScheme = {read=FColorScheme, write=SetColorScheme, nodefault};
	__property Graphics::TColor DayNames = {read=GetColor, write=SetColor, index=1, nodefault};
	__property Graphics::TColor Days = {read=GetColor, write=SetColor, index=2, nodefault};
	__property Graphics::TColor InactiveDays = {read=GetColor, write=SetColor, index=3, nodefault};
	__property Graphics::TColor MonthAndYear = {read=GetColor, write=SetColor, index=4, nodefault};
	__property Graphics::TColor Weekend = {read=GetColor, write=SetColor, index=5, nodefault};
public:
	/* TPersistent.Destroy */ __fastcall virtual ~TEsCalColors(void) { }
	
public:
	/* TObject.Create */ __fastcall TEsCalColors(void) : Classes::TPersistent() { }
	
};

typedef void __fastcall (__closure *TDateChangeEvent)(System::TObject* Sender, System::TDateTime Date
	);

class DELPHICLASS TEsCustomCalendar;
class PASCALIMPLEMENTATION TEsCustomCalendar : public Esbase::TEsBase 
{
	typedef Esbase::TEsBase inherited;
	
protected:
	bool FBrowsing;
	TEsCalColors* FColors;
	System::TDateTime FDate;
	TEsDateFormat FDateFormat;
	TEsDayNameWidth FDayNameWidth;
	bool FShowDate;
	bool FShowInactive;
	bool FShowToday;
	TFormBorderStyle FBorderStyle;
	TEsDayType FWeekStarts;
	TDateChangeEvent FOnChange;
	Buttons::TSpeedButton* clBtnLeft;
	Buttons::TSpeedButton* clBtnRight;
	Buttons::TSpeedButton* clBtnToday;
	bool clInPopup;
	Buttons::TSpeedButton* clBtnNextYear;
	Buttons::TSpeedButton* clBtnPrevYear;
	Byte clCalendar[42];
	Word clDay;
	Byte clFirst;
	Byte clLast;
	Word clMonth;
	Windows::TRect clRowCol[8][7];
	bool cSettingScheme;
	Word clYear;
	int clWidth;
	bool clPopup;
	void __fastcall SetBorderStyle(Forms::TBorderStyle Value);
	void __fastcall SetDate(System::TDateTime Value);
	void __fastcall SetDateFormat(TEsDateFormat Value);
	void __fastcall SetDayNameWidth(TEsDayNameWidth Value);
	void __fastcall SetShowDate(bool Value);
	void __fastcall SetShowInactive(bool Value);
	void __fastcall SetShowToday(bool Value);
	void __fastcall SetWeekStarts(TEsDayType Value);
	void __fastcall calBtnClick(System::TObject* Sender);
	void __fastcall calChangeMonth(System::TObject* Sender);
	void __fastcall calColorChange(System::TObject* Sender);
	Windows::TRect __fastcall calGetCurrentRectangle();
	void __fastcall calRebuildCalArray(void);
	void __fastcall calRecalcSize(void);
	HIDESBASE MESSAGE void __fastcall CMCtl3DChanged(Messages::TMessage &Msg);
	HIDESBASE MESSAGE void __fastcall CMEnter(Messages::TMessage &Msg);
	HIDESBASE MESSAGE void __fastcall CMExit(Messages::TMessage &Msg);
	HIDESBASE MESSAGE void __fastcall CMFontChanged(Messages::TMessage &Msg);
	HIDESBASE MESSAGE void __fastcall WMEraseBkgnd(Messages::TWMEraseBkgnd &Msg);
	MESSAGE void __fastcall WMGetDlgCode(Messages::TWMNoParams &Msg);
	virtual void __fastcall CreateParams(Controls::TCreateParams &Params);
	virtual void __fastcall CreateWnd(void);
	DYNAMIC void __fastcall DoOnChange(System::TDateTime Value);
	DYNAMIC void __fastcall DoOnMouseWheel(Classes::TShiftState Shift, short Delta, short XPos, short YPos
		);
	DYNAMIC void __fastcall KeyDown(Word &Key, Classes::TShiftState Shift);
	DYNAMIC void __fastcall KeyPress(char &Key);
	DYNAMIC void __fastcall MouseDown(Controls::TMouseButton Button, Classes::TShiftState Shift, int X, 
		int Y);
	DYNAMIC void __fastcall MouseUp(Controls::TMouseButton Button, Classes::TShiftState Shift, int X, int 
		Y);
	virtual void __fastcall Paint(void);
	
public:
	__fastcall virtual TEsCustomCalendar(Classes::TComponent* AOwner);
	__fastcall virtual TEsCustomCalendar(Classes::TComponent* AOwner, bool AsPopup);
	__fastcall virtual ~TEsCustomCalendar(void);
	virtual void __fastcall SetBounds(int ALeft, int ATop, int AWidth, int AHeight);
	__property Forms::TBorderStyle BorderStyle = {read=FBorderStyle, write=SetBorderStyle, default=0};
	__property bool Browsing = {read=FBrowsing, nodefault};
	__property TEsCalColors* Colors = {read=FColors, write=FColors};
	__property TEsDayNameWidth DayNameWidth = {read=FDayNameWidth, write=SetDayNameWidth, default=3};
	__property System::TDateTime Date = {read=FDate, write=SetDate};
	__property TEsDateFormat DateFormat = {read=FDateFormat, write=SetDateFormat, default=1};
	__property bool ShowDate = {read=FShowDate, write=SetShowDate, default=1};
	__property bool ShowInactive = {read=FShowInactive, write=SetShowInactive, default=0};
	__property bool ShowToday = {read=FShowToday, write=SetShowToday, default=1};
	__property TEsDayType WeekStarts = {read=FWeekStarts, write=SetWeekStarts, default=0};
	__property TDateChangeEvent OnChange = {read=FOnChange, write=FOnChange};
public:
	/* TWinControl.CreateParented */ __fastcall TEsCustomCalendar(HWND ParentWindow) : Esbase::TEsBase(
		ParentWindow) { }
	
};

class DELPHICLASS TEsCalendar;
class PASCALIMPLEMENTATION TEsCalendar : public Escal::TEsCustomCalendar 
{
	typedef Escal::TEsCustomCalendar inherited;
	
__published:
	__property Align ;
	__property BorderStyle ;
	__property Colors ;
	__property Ctl3D ;
	__property Cursor ;
	__property DayNameWidth ;
	__property DateFormat ;
	__property DragCursor ;
	__property DragMode ;
	__property Enabled ;
	__property EsLabelInfo ;
	__property Font ;
	__property ParentCtl3D ;
	__property ParentFont ;
	__property ParentShowHint ;
	__property PopupMenu ;
	__property ShowDate ;
	__property ShowHint ;
	__property ShowInactive ;
	__property ShowToday ;
	__property TabOrder ;
	__property TabStop ;
	__property Version ;
	__property Visible ;
	__property WeekStarts ;
	__property OnChange ;
	__property OnDblClick ;
	__property OnDragDrop ;
	__property OnDragOver ;
	__property OnEndDrag ;
	__property OnEnter ;
	__property OnExit ;
	__property OnKeyDown ;
	__property OnKeyPress ;
	__property OnKeyUp ;
	__property OnMouseDown ;
	__property OnMouseMove ;
	__property OnMouseUp ;
	__property OnStartDrag ;
public:
	/* TEsCustomCalendar.Create */ __fastcall virtual TEsCalendar(Classes::TComponent* AOwner) : Escal::
		TEsCustomCalendar(AOwner) { }
	/* TEsCustomCalendar.CreateEx */ __fastcall virtual TEsCalendar(Classes::TComponent* AOwner, bool AsPopup
		) : Escal::TEsCustomCalendar(AOwner, AsPopup) { }
	/* TEsCustomCalendar.Destroy */ __fastcall virtual ~TEsCalendar(void) { }
	
public:
	/* TWinControl.CreateParented */ __fastcall TEsCalendar(HWND ParentWindow) : Escal::TEsCustomCalendar(
		ParentWindow) { }
	
};

//-- var, const, procedure ---------------------------------------------------
#define calDefBorderStyle (Forms::TFormBorderStyle)(0)
#define calDefColor (int)(-2147483633)
#define calDefDateFormat (TEsDateFormat)(1)
#define calDefDayNameWidth (Byte)(3)
#define calDefHeight (Byte)(140)
#define calDefShowDate (bool)(1)
#define calDefShowInactive (bool)(0)
#define calDefShowToday (bool)(1)
#define calDefTabStop (bool)(1)
#define calDefWeekStarts (TEsDayType)(0)
#define calDefWidth (Byte)(200)
#define calMargin (Byte)(4)
extern PACKAGE Graphics::TColor CalScheme[5][6];

}	/* namespace Escal */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Escal;
#endif
//-- end unit ----------------------------------------------------------------
#endif	// EsCal
