// Borland C++ Builder
// Copyright (c) 1995, 1998 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'EsLabel.pas' rev: 3.00

#ifndef EsLabelHPP
#define EsLabelHPP
#include <EsUtil.hpp>
#include <EsData.hpp>
#include <EsConst.hpp>
#include <SysUtils.hpp>
#include <StdCtrls.hpp>
#include <Messages.hpp>
#include <Graphics.hpp>
#include <Controls.hpp>
#include <Classes.hpp>
#include <Windows.hpp>
#include <SysInit.hpp>
#include <System.hpp>

//-- user supplied -----------------------------------------------------------

namespace Eslabel
{
//-- type declarations -------------------------------------------------------
enum TEsAppearance { apNone, apCustom, apFlying, apRaised, apSunken, apShadow };

enum TEsColorScheme { csCustom, csText, csWindows, csEmbossed, csGold, csSteel };

enum TEsGraduateStyle { gsNone, gsHorizontal, gsVertical };

enum TEsShadeDirection { sdNone, sdUp, sdUpRight, sdRight, sdDownRight, sdDown, sdDownLeft, sdLeft, 
	sdUpLeft };

enum TEsShadeStyle { ssPlain, ssExtrude, ssGraduated };

typedef Byte TEsDepth;

class DELPHICLASS TEsCustomSettings;
class PASCALIMPLEMENTATION TEsCustomSettings : public Classes::TPersistent 
{
	typedef Classes::TPersistent inherited;
	
private:
	Graphics::TColor FGraduateFromColor;
	TEsGraduateStyle FGraduateStyle;
	Graphics::TColor FHighlightColor;
	TEsDepth FHighlightDepth;
	TEsShadeDirection FHighlightDirection;
	TEsShadeStyle FHighlightStyle;
	Graphics::TColor FShadowColor;
	TEsDepth FShadowDepth;
	TEsShadeDirection FShadowDirection;
	TEsShadeStyle FShadowStyle;
	Classes::TNotifyEvent FOnColorChange;
	Classes::TNotifyEvent FOnStyleChange;
	bool FUpdating;
	void __fastcall DoOnColorChange(void);
	void __fastcall DoOnStyleChange(void);
	void __fastcall SetGraduateFromColor(Graphics::TColor Value);
	void __fastcall SetGraduateStyle(TEsGraduateStyle Value);
	void __fastcall SetHighlightColor(Graphics::TColor Value);
	void __fastcall SetHighlightDepth(TEsDepth Value);
	void __fastcall SetHighlightDirection(TEsShadeDirection Value);
	void __fastcall SetHighlightStyle(TEsShadeStyle Value);
	void __fastcall SetShadowColor(Graphics::TColor Value);
	void __fastcall SetShadowDepth(TEsDepth Value);
	void __fastcall SetShadowDirection(TEsShadeDirection Value);
	void __fastcall SetShadowStyle(TEsShadeStyle Value);
	
public:
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	void __fastcall BeginUpdate(void);
	void __fastcall EndUpdate(void);
	__property Classes::TNotifyEvent OnColorChange = {read=FOnColorChange, write=FOnColorChange};
	__property Classes::TNotifyEvent OnStyleChange = {read=FOnStyleChange, write=FOnStyleChange};
	
__published:
	__property Graphics::TColor GraduateFromColor = {read=FGraduateFromColor, write=SetGraduateFromColor
		, default=8421504};
	__property TEsGraduateStyle GraduateStyle = {read=FGraduateStyle, write=SetGraduateStyle, default=0
		};
	__property Graphics::TColor HighlightColor = {read=FHighlightColor, write=SetHighlightColor, default=16777215
		};
	__property TEsDepth HighlightDepth = {read=FHighlightDepth, write=SetHighlightDepth, default=1};
	__property TEsShadeDirection HighlightDirection = {read=FHighlightDirection, write=SetHighlightDirection
		, default=8};
	__property TEsShadeStyle HighlightStyle = {read=FHighlightStyle, write=SetHighlightStyle, default=0
		};
	__property Graphics::TColor ShadowColor = {read=FShadowColor, write=SetShadowColor, default=0};
	__property TEsDepth ShadowDepth = {read=FShadowDepth, write=SetShadowDepth, default=1};
	__property TEsShadeDirection ShadowDirection = {read=FShadowDirection, write=SetShadowDirection, default=4
		};
	__property TEsShadeStyle ShadowStyle = {read=FShadowStyle, write=SetShadowStyle, default=0};
public:
		
	/* TPersistent.Destroy */ __fastcall virtual ~TEsCustomSettings(void) { }
	
public:
	/* TObject.Create */ __fastcall TEsCustomSettings(void) : Classes::TPersistent() { }
	
};

enum EsLabel__3 { cpHighlight, cpShadow, cpFace };

class DELPHICLASS TEsCustomLabel;
class PASCALIMPLEMENTATION TEsCustomLabel : public Stdctrls::TCustomLabel 
{
	typedef Stdctrls::TCustomLabel inherited;
	
protected:
	TEsAppearance FAppearance;
	TEsColorScheme FColorScheme;
	TEsCustomSettings* FCustomSettings;
	Graphics::TColor eslSchemes[6][3];
	bool SettingColorScheme;
	bool SettingAppearance;
	System::AnsiString __fastcall GetVersion();
	bool __fastcall GetWordWrap(void);
	void __fastcall SetAppearance(TEsAppearance Value);
	void __fastcall SetColorScheme(TEsColorScheme Value);
	HIDESBASE void __fastcall SetWordWrap(bool Value);
	void __fastcall SetVersion(const System::AnsiString Value);
	void __fastcall PaintPrim(const Windows::TRect &CR, Word Flags);
	void __fastcall ColorChanged(System::TObject* Sender);
	void __fastcall StyleChanged(System::TObject* Sender);
	virtual void __fastcall Paint(void);
	__property TEsAppearance Appearance = {read=FAppearance, write=SetAppearance, default=3};
	__property TEsColorScheme ColorScheme = {read=FColorScheme, write=SetColorScheme, default=2};
	__property TEsCustomSettings* CustomSettings = {read=FCustomSettings, write=FCustomSettings};
	__property System::AnsiString Version = {read=GetVersion, write=SetVersion, stored=false};
	__property bool WordWrap = {read=GetWordWrap, write=SetWordWrap, default=1};
	
public:
	__fastcall virtual TEsCustomLabel(Classes::TComponent* AOwner);
	__fastcall virtual ~TEsCustomLabel(void);
	void __fastcall PaintTo(int DC, const Windows::TRect &CR, Word Flags);
	__property AutoSize ;
};

class DELPHICLASS TEsLabel;
class PASCALIMPLEMENTATION TEsLabel : public Eslabel::TEsCustomLabel 
{
	typedef Eslabel::TEsCustomLabel inherited;
	
__published:
	__property Align ;
	__property Alignment ;
	__property Appearance ;
	__property Caption ;
	__property Color ;
	__property ColorScheme ;
	__property Cursor ;
	__property CustomSettings ;
	__property DragCursor ;
	__property DragMode ;
	__property Enabled ;
	__property FocusControl ;
	__property Font ;
	__property ParentColor ;
	__property ParentFont ;
	__property ParentShowHint ;
	__property ShowAccelChar ;
	__property ShowHint ;
	__property Transparent ;
	__property Version ;
	__property Visible ;
	__property WordWrap ;
	__property OnClick ;
	__property OnDblClick ;
	__property OnDragDrop ;
	__property OnDragOver ;
	__property OnEndDrag ;
	__property OnMouseDown ;
	__property OnMouseMove ;
	__property OnMouseUp ;
public:
	/* TEsCustomLabel.Create */ __fastcall virtual TEsLabel(Classes::TComponent* AOwner) : Eslabel::TEsCustomLabel(
		AOwner) { }
	/* TEsCustomLabel.Destroy */ __fastcall virtual ~TEsLabel(void) { }
	
};

//-- var, const, procedure ---------------------------------------------------
#define lblDefAppearance (TEsAppearance)(3)
#define lblDefAutoSize (bool)(0)
#define lblDefColorScheme (TEsColorScheme)(2)
#define lblDefFontName "Times New Roman"
#define lblDefFontSize (Byte)(20)
#define lblDefGraduateFromColor (int)(8421504)
#define lblDefGraduateStyle (TEsGraduateStyle)(0)
#define lblDefHighlightColor (int)(16777215)
#define lblDefHighlightDepth (Byte)(1)
#define lblDefHighlightDirection (TEsShadeDirection)(8)
#define lblDefHighlightStyle (TEsShadeStyle)(0)
#define lblDefShadowColor (int)(0)
#define lblDefShadowDepth (Byte)(1)
#define lblDefShadowDirection (TEsShadeDirection)(4)
#define lblDefShadowStyle (TEsShadeStyle)(0)
#define lblDefTransparent (bool)(1)
#define lblDefWordWrap (bool)(1)

}	/* namespace Eslabel */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Eslabel;
#endif
//-- end unit ----------------------------------------------------------------
#endif	// EsLabel
